--- crash-4.0-3.6/defs.h	2006-10-05 21:43:10.000000000 +0200
+++ crash-4.0-3.6-patch/defs.h	2006-10-11 18:38:36.000000000 +0200
@@ -1603,6 +1603,8 @@
 
 #define union_name struct_name
 
+#define STRUCTNAME_INC 4
+#define STRUCTNAME_ALLOC(X) ((sizeof(char*)*STRUCTNAME_INC)*(X))
 struct list_data {             /* generic structure used by do_list() to walk */
         ulong flags;           /* through linked lists in the kernel */
         ulong start;
@@ -1610,7 +1612,8 @@
 	long list_head_offset;
         ulong end;
 	ulong searchfor;
-	char *structname;
+	char **structname;
+	int structname_size;
 	char *header;
 };
 #define LIST_OFFSET_ENTERED  (VERBOSE << 1)
--- crash-4.0-3.6/tools.c	2006-10-05 21:43:10.000000000 +0200
+++ crash-4.0-3.6-patch/tools.c	2006-10-11 18:32:09.000000000 +0200
@@ -2818,6 +2818,7 @@
 	struct datatype_member struct_member, *sm;
 	struct syment *sp;
 	ulong value; 
+	int structname_inc=0;
 
 	sm = &struct_member;
 	ld = &list_data;
@@ -2836,7 +2837,18 @@
 			break;
 
 		case 's':
-			ld->structname = optarg;
+			if(ld->structname_size == 0) {
+				ld->structname = (char**)GETBUF(STRUCTNAME_ALLOC(1));
+				structname_inc++;
+			} else if (ld->structname_size % STRUCTNAME_INC == 0) {
+				char **structname_save;
+				structname_inc++;
+				structname_save = ld->structname;
+				ld->structname = (char **)GETBUF(STRUCTNAME_ALLOC(structname_inc));
+				BCOPY(structname_save,ld->structname,STRUCTNAME_ALLOC(structname_inc-1));
+			}
+			ld->structname[ld->structname_size] = optarg;
+			ld->structname_size++;
 			break;
 
 		case 'o':
@@ -3084,20 +3096,22 @@
 			fprintf(fp, "%lx\n", next - ld->list_head_offset);
 
 			if (ld->structname) {
-				switch (count_chars(ld->structname, '.'))
+				int i;
+				for (i=0; i < ld->structname_size ;i++)
+					switch (count_chars(ld->structname[i], '.'))
 				{
 				case 0:
-					dump_struct(ld->structname, 
+						dump_struct(ld->structname[i], 
 						next - ld->list_head_offset, 0);
 					break;
 				case 1:
-					dump_struct_member(ld->structname, 
+						dump_struct_member(ld->structname[i], 
 						next - ld->list_head_offset, 0);
 					break;
 				default:
 					error(FATAL, 
 					    "invalid structure reference: %s\n",
-						ld->structname);
+							ld->structname[i]);
 				}
 			}
 		}
@@ -3162,7 +3176,8 @@
 
 	if (CRASHDEBUG(1))
 		console("do_list count: %d\n", count);
-
+	if (ld->structname)
+			FREEBUF(ld->structname);
 	return count;
 }
 
--- crash-4.0-3.6/help.c	2006-10-05 21:43:10.000000000 +0200
+++ crash-4.0-3.6-patch/help.c	2006-10-11 18:35:45.000000000 +0200
@@ -3482,7 +3482,7 @@
 char *help__list[] = {
 "list",
 "linked list",
-"[[-o] offset] [-e end] [-s struct[.member]] [-H] start",
+"[[-o] offset] [-e end] [-s struct[.member] [-s struct[.member] ... ] [-H] start",
 "  This command dumps the contents of a linked list.  The entries in a linked",
 "  list are typically data structures that are tied together in one of two",
 "  formats:",
